//-*-c++-*-
#ifndef MOUSEZOOMBOX_H
#define MOUSEZOOMBOX_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <tulip/MouseInterface.h>

class SuperGraph;
class QMouseEvent;
class QKeyEvent;
/** \addtogroup Mouse_interactor */ 
/*@{*/

class TLP_QT_SCOPE MouseZoomBox : public MouseInterface {

public:
  MouseZoomBox();
  ~MouseZoomBox();
  void mPressEvent(GlGraphWidget *,QMouseEvent *);
  void mReleaseEvent(GlGraphWidget *,QMouseEvent *);
  void mMoveEvent(GlGraphWidget *,QMouseEvent *);
  void mPaint(GlGraphWidget *);
  void keyPressEvent (GlGraphWidget *, QKeyEvent *){}
  void keyReleaseEvent(GlGraphWidget *, QKeyEvent *){}
  void wheelEvent(GlGraphWidget *, QWheelEvent *){}
  MouseInterface * clone() { return new MouseZoomBox();}

private:
  unsigned int x, y;
  int w, h;
  bool started;
  SuperGraph *superGraph;
};
/*@}*/
#endif //MOUSEZOOMBOX_H
